; dxCameraFogColor Example
; ----------------------

dxGraphics3D 640,480
dxSetBuffer dxBackBuffer()

camera=dxCreateCamera()
dxPositionEntity camera,0,1,0

light=dxCreateLight()
dxRotateEntity light,90,0,0

plane=dxCreatePlane()
grass_tex=dxLoadTexture( "media/mossyground.bmp" )
dxEntityTexture plane,grass_tex

; Set camera fog to 1 (linear fog)
dxCameraFogMode camera,1

; Set camera fog range
dxCameraFogRange camera,1,10

; Set initial fog colour values
red#=0
green#=0
blue#=0

While Not dxKeyDown( 1 )

; Change red, green, blue values depending on key pressed
If dxKeyDown( 2 )=True And red#>0 Then red#=red#-1
If dxKeyDown( 3 )=True And red#<255 Then red#=red#+1
If dxKeyDown( 4 )=True And green#>0 Then green#=green#-1
If dxKeyDown( 5 )=True And green#<255 Then green#=green#+1
If dxKeyDown( 6 )=True And blue#>0 Then blue#=blue#-1
If dxKeyDown( 7 )=True And blue#<255 Then blue#=blue#+1

; Set camera fog dxColor using red, green, blue values
dxCameraFogColor camera,red#,green#,blue#

If dxKeyDown( 205 )=True Then dxTurnEntity camera,0,-1,0
If dxKeyDown( 203 )=True Then dxTurnEntity camera,0,1,0
If dxKeyDown( 208 )=True Then dxMoveEntity camera,0,0,-0.05
If dxKeyDown( 200 )=True Then dxMoveEntity camera,0,0,0.05

dxRenderWorld

dxText 0,0,"Use cursor keys to move about the infinite plane"
dxText 0,20,"Press keys 1-6 to change dxCameraFogColor red#,green#,blue# values
dxText 0,40,"Fog Red: "+red#
dxText 0,60,"Fog Green: "+green#
dxText 0,80,"Fog Blue: "+blue#

dxFlip

Wend

End
