; dxCameraProjMode Example
; ----------------------

dxGraphics3D 640,480
dxSetBuffer dxBackBuffer()

camera=dxCreateCamera()
dxPositionEntity camera,0,0,-10

light=dxCreateLight()
dxRotateEntity light,0,0,0

; Create cube 1, near to camera
cube1=dxCreateCube()
dxEntityColor cube1,255,0,0
dxPositionEntity cube1,0,0,0

; Create cube 2, same size as cube 1 but further away
cube2=dxCreateCube()
dxEntityColor cube2,0,255,0
dxPositionEntity cube2,5,5,5

While Not dxKeyDown( 1 )

; If spacebar pressed then change mode value
If dxKeyHit(57)=True Then mode=mode+1 : If mode=3 Then mode=0

; If mode value = 2 (orthagraphic), then reduce zoom value to 0.1
If mode=2 Then zoom#=0.1 Else zoom#=1

; Set camera projection mode using mode value
dxCameraProjMode camera,mode

; Set camera zoom using zoom value
dxCameraZoom camera,zoom#

dxRenderWorld

dxText 0,0,"Press spacebar to change the camera project mode"
dxText 0,20,"dxCameraProjMode camera,"+mode
dxText 0,40,"dxCameraZoom camera,"+zoom#

dxFlip

dxCls

Wend

End
